#ifndef _INCLUDE_FSTREAM_H
#define _INCLUDE_FSTREAM_H

/*
**  $VER: fstream.h 10.1 (19.7.95)
**  Includes Release 40.15
**
**  '(C) Copyright 1995/96 Haage & Partner Computer GmbH'
**	 All Rights Reserved
*/

#ifndef _INCLUDE_STREAM_H
#include <stream.h>
#endif

typedef long streampos;
typedef long streamoff;

class fstreambase: public virtual ios
{ protected:
   fstreambase(FILE *f=0);
   ~fstreambase();
  public:
   FILE *open(const char*, int);
   void close();
   int buffer(unsigned s);
   void flush();
   int seekg(long, int=ios::beg);
   long tellg();
};

class ofstream: public ostream, public fstreambase
{ public:
   ofstream();
   ofstream(const char*, int = ios::out);
   ~ofstream();
};

class ifstream: public istream, public fstreambase
{
  public:
   ifstream();
   ifstream(const char*, int = ios::in);
   ~ifstream();
};

class fstream: public ostream, public istream, public fstreambase
{ public:
   fstream();
   fstream(const char*, int);
   ~fstream();
};
#endif

