#ifndef _INCLUDE_STDIO_H
#define _INCLUDE_STDIO_H

/*
**  $VER: stdio.h 10.1 (19.7.95)
**  Includes Release 40.15
**
**  '(C) Copyright 1995 Haage & Partner Computer GmbH'
**	 All Rights Reserved
*/

#ifdef __cplusplus
extern "C" {
#endif

struct stream;
typedef stream FILE;
extern FILE std__in, std__out, std__err;

#ifndef NULL
#define NULL 0
#endif

typedef unsigned size_t;

#define stdin (&std__in)
#define stdout (&std__out)
#define stderr (&std__err)

#define EOF (-1)

int getc(FILE *);
int fgetc(FILE*);
int getchar (void);
int ungetc(int, FILE*);

#define STREAM_MAXSTRING 80     // maximal von "gets" in String gelesene Zeichen
char *fgets(char*, int, FILE*);
char *gets(char*);

int fputc(int, FILE*);
int putc(int, FILE*);
int putchar(int);
int fputs(const char*, FILE*);
int puts(const char*);
void perror(const char*);

#define FILENAME_MAX 200
#define FOPEN_MAX 99999
FILE *fopen(const char*, const char*);
FILE *freopen(const char*, const char*, FILE*);
int fclose(FILE*);
int feof(FILE*);
int ferror(FILE*);
void clearerr(FILE*);

#define _IOFBF 1
#define _IOLBF (-1)
#define _IONBF 0
#define BUFSIZ 200
int setvbuf(FILE*, char*, int, unsigned);
void setbuf(FILE*, char*);
int fflush(FILE*);

int printf(const char*, ...);
int fprintf(FILE*, const char*, ...);
int sprintf(char*, const char*, ...);
typedef unsigned va_list;
int vprintf(const char*, va_list);
int vfprintf(FILE*, const char*, va_list);
int vsprintf(char*, const char*, va_list);

int scanf(const char*, ...);
int fscanf(FILE*, const char*, ...);
int sscanf(const char*, const char*, ...);

int remove(const char*);
int rename(const char*, const char*);

#define L_tmpnam 40
#define TMP_MAX 0x10000
char *tmpnam (char s[L_tmpnam]);
FILE *tmpfile (void);

unsigned fread(void *, unsigned, unsigned, FILE*);
unsigned fwrite(const void *, unsigned, unsigned, FILE*);

#define SEEK_CUR 0
#define SEEK_END 1
#define SEEK_SET (-1)
typedef int fpos_t;
int fseek(FILE*, long, int);
long ftell(FILE*);
void rewind(FILE*);
int fgetpos(FILE*, int*);
int fsetpos(FILE*, const int*);

void exit(int);

#ifdef __cplusplus
}
#endif

#endif

